/*********************************************************************
*  CH08_07.C  	        	               		  Pointeurs  *
*			       Passage de fonctions comme arguments  *
*********************************************************************/

#include<stdio.h>
#include"c:\albulus\chap_07\ctes.h"

void affiche_1( double);
void affiche_2( double);
void affiche_3( double);

void (*pointeur_sur_fonction)( double);

main( void)
{
	affiche_1( C_me);                   /* appel normal	*/
	pointeur_sur_fonction = affiche_1;  /* affectation      */
	pointeur_sur_fonction( C_me);       /* appel indirect   */
        printf("\n");

	affiche_2( PI);                     /* appel normal	*/
	pointeur_sur_fonction = affiche_2;
	pointeur_sur_fonction( PI);
	printf("\n");

	affiche_2( C_R);                     /* appel normal	*/
	pointeur_sur_fonction( C_R);
	printf("\n");

	affiche_3( C_mn);                    /* appel normal	*/
	pointeur_sur_fonction = affiche_3;
	pointeur_sur_fonction( C_mn);
}

void affiche_1( double rien)
{
   printf("Je n'affiche aucune valeur.\n");
}

void affiche_2(double a2)
{
   printf("J'affiche des rels sans exposants:  %lf\n", a2);
}

void affiche_3(double a3)
{
   printf("J'affiche des rels avec exposants: %lE\n", a3);
}
/* 

   Je n'affiche aucune valeur.
   Je n'affiche aucune valeur.

   J'affiche des rels sans exposants: 3.141593
   J'affiche des rels sans exposants: 3.141593

   J'affiche des rels sans exposants: 8.314110
   J'affiche des rels sans exposants: 8.314110

   J'affiche des rels avec exposants: 1.674954E-27
   J'affiche des rels avec exposants: 1.674954E-27		    */
