/*********************************************************************
*  CH09_09.C  	              		  Addition de deux matrices  *
*			      En utilisant la notation des tableaux  *
*********************************************************************/

#include<stdio.h>

#define dim1 2
#define dim2 3

int LitInt( void);
void Initialise( int[][dim2]);
void Affiche( int[][dim2]);
void Addition( int [][dim2], int [][dim2], int [][dim2]);

main( void)
{
	int tab0[dim1][dim2], tab1[dim1][dim2], tab2[dim1][dim2];

	Initialise( tab1);
	Initialise( tab2);       

	Addition( tab0, tab1, tab2);   

	Affiche( tab0);
}

void Addition( int t0[][dim2], int t1[][dim2], int t2[][dim2])
{
      int i, j;

      for( i= 0; i< dim1; i++)
      {
          for( j= 0; j< dim2; j++)
	  {
	     t0[i][j]=  t1[i][j]+ t2[i][j];
	  }
      }
}

void Initialise( int t[][dim2])
{
      int i, j;

      printf("\n Initialisation d'une matrice [%d][%d]\n",
        					         dim1, dim2);

      for( i= 0; i< dim1; i++)
      {
          for( j= 0; j< dim2; j++)
	  {
	     printf(" tab[%d][%d]=  ", i, j);
	     t[i][j]= LitInt();
	  }
      }
}

void Affiche( int t[][dim2])
{
      int i, j;

      for( i= 0; i< dim1; i++)
      {
          for( j= 0; j< dim2; j++)
	  {
	     printf("\n tab[%d][%d]=  %d", i, j, t[i][j]);
	  }
      }
}

int LitInt( void)
{
	double dble;
	do
        {
	   while( scanf("%lf", &dble)!= 1)
		while( getchar() != '\n');
	   while( getchar() != '\n');
	}
	while( dble< -32768.0 || dble> 32767.0);
	return ( (int) dble);
}

/*
 Initialisation d'une matrice [2][3]
 tab[0][0]=  0
 tab[0][1]=  1
 tab[0][2]=  2
 tab[1][0]=  3
 tab[1][1]=  4
 tab[1][2]=  5

 Initialisation d'une matrice [2][3]
 tab[0][0]=  5
 tab[0][1]=  4
 tab[0][2]=  3
 tab[1][0]=  2
 tab[1][1]=  1
 tab[1][2]=  0

 tab[0][0]=  5
 tab[0][1]=  5
 tab[0][2]=  5
 tab[1][0]=  5
 tab[1][1]=  5
 tab[1][2]=  5							   */




