/*********************************************************************
*  CH15_02.C  		    		   Enregistrement et lecture *
*     de chanes de caractres dans un fichier avec fputs(), fgets() *
*********************************************************************/

#include<stdio.h>
#include<process.h>                  /* pour la fonction exit()     */

#define dim 16

main( void)
{
/* 1. Dclaration d'un pointeur sur la structure FILE.              */
	FILE *flux1, *flux2;
	char fichier[]= "c:\\albulus\\chap_15\\exercice.txt",
	     chaine1[dim], chaine2[dim];
        
/* 2. Ouverture du fichier en criture.                             */				    
	if( ( flux1= fopen( fichier, "wt") )== NULL)
	  {
	     printf("\n Ecriture: le fichier n'a pu tre ouvert!\n");
	     exit( 1);
          }
/* 3. Lecture.                                                      */
	printf("\n Entrez une chane de moins de %d caractres: ",
		dim);
	if( gets( chaine1)== NULL)
		printf("\n Erreur  la saisie!\n");

/* 4. Enregistrement dans le fichier.                               */                                
	if( fputs( chaine1, flux1)== EOF)
		printf("\n Erreur  l'enregistrement!\n");

/* 5. Fermeture du fichier.                                         */					    
	if( fclose( flux1)== EOF)
		printf("\n Erreur  la premire fermeture!\n");

/* 6. Ouverture du fichier en lecture.                              */
	if( ( flux2= fopen( fichier, "rt") )== NULL)
	   printf("\n Lecture: le fichier n'a pu tre ouvert!\n");

/* 7. Lecture et affichage du fichier.       			    */
	else
	{
	   if( fgets( chaine2, sizeof( chaine2), flux2)== NULL)
	   	printf("\n Erreur  la lecture!\n");
	   if( puts( chaine2)< 0)
		printf("\n Erreur  l'affichage!\n");
	}
/* 8. Fermeture du fichier.					    */
	if( fclose( flux2))
		printf("\n Erreur  la seconde fermeture!\n");
}
