/*********************************************************************
*  CH15_04.C                                Ecriture dans un fichier *
*				       fonctions fprintf(), fscanf() *
*********************************************************************/

#include<stdio.h>
#include<process.h>

#define dim 16
#define fichier "c:\\albulus\\chap_15\\exercice.txt"

main( void)
{
	FILE *flux;
	char chaine[dim];
        int x= 12345;

   /* 1. Ouverture du fichier.					    */
	if( ( flux= fopen( fichier, "wt") )== NULL)
	  {
	     fprintf( stderr,"\n le fichier n'a pu tre ouvert!\n");
	     exit( 1);
	  }
   /* 2. Saisie d'une chane.					    */
	fprintf( stdout,
	" Entrez une chaine de dimension infrieure  %d:   ", dim);

	while( fscanf( stdin, "%s", chaine)!= 1)
		while( getchar() != '\n');
	   while( getchar() != '\n');

   /* 3. Ecriture contrle de la chane dans le fichier.           */
	if( fprintf( flux, "%s ", chaine)== EOF)
	{
	   fprintf( stderr,"\n L'criture n'a pu tre faite!\n");
	   exit(1);
	}
   /* 4. Fermeture du fichier.					    */
	if( fclose( flux)== EOF)
	   fprintf( stderr,"\n Erreur  la 1re fermeture!\n");

   /* 5. Ouverture du fichier pour y ajouter une donne.       	    */
	if( ( flux= fopen( fichier, "at") )== NULL)
	  {
	     fprintf( stderr,"\n le fichier n'a pu tre reouvert!\n");
	     exit( 1);
	  }

   /* 6. Ecriture d'un entier dans le fichier et fermeture.	    */
	if( fprintf( flux, "%d ", x)== EOF)
	{
	   fprintf( stderr,"\n L'criture n'a pu tre faite!\n");
	   exit(1);
	}
	if( fclose( flux))
	   fprintf( stderr, "\n Erreur  la 2me fermeture!\n");
}

/*

Petrus_Albulus!

*/