/*********************************************************************
*  CH15_05.C                                 Lecture dans un fichier *
*				       fonctions fprintf(), fscanf() *
*********************************************************************/

#include<stdio.h>
#include<process.h>

#define dim 16
#define fichier "c:\\albulus\\chap_15\\exercice.txt"

main( void)
{
	char chaine[dim];
        int x;
	FILE *flux;

   /* 1. Ouverture du fichier.					    */
	if( ( flux= fopen( fichier, "rt") )== NULL)
	  {
	     printf("\n Ecriture: le fichier n'a pu tre ouvert!\n");
	     exit( 1);
	  }
   /* 2. Lecture dans le fichier et affichage de la chane.	    */
	if( fscanf( flux, "%s", chaine) == EOF)
        {
	   printf("\n Erreur d'criture d'une chane!\n");
	   exit(1);
	}
	printf("\n Ecriture d'une chane: %s", chaine);

   /* 3. Lecture dans le fichier et affichage du nombre entier.	    */
	if( fscanf( flux, "%d", &x) == EOF)
        {
	   printf("\n Erreur d'criture d'une chane!\n");
	   exit(1);
	}
	printf("\n Ecriture d'un entier: %d", x);

	fclose( flux);
}

