/*********************************************************************
*  CH02_05.C       Exemple de sortie du domaine de dfinition des    *
						       unsigned int  *
*********************************************************************/

#include<stdio.h>     

main( void)
{
    unsigned int y0, y1, y2,
    entier_0= 420, entier_1= 160, entier_2= 4;

    /* Le suffixe U ou u qualifie une constante du type unsigned int
       nous aurions pu dclarer: entier_0= 420u, entier_1= 160U

       De mme le suffixe L ou l qualifie une constante de type long
       Une constante unsigned long int pourra s'crire 420UL        */

    y0= entier_0;               /* y0= 420                          */
    y1= y0* entier_1;           /* y1= 67200                        */
    y2= y1/ entier_2;           /* y2= 16800 en dcimal             */

    printf(" Le rsultat:\t y0= %u\n\t\t"
			  " y1= %u\n\t\t"
			  " y2= %u", y0, y1, y2);

}

/*  Le programme nous affiche:

 Le rsultat:	y0= 420
		y1= 1664         1664= 67200- ( 65535+ 1)
		y2= 416

 En fait l'opration s'crit: 		y2= 440* 160/ 4
 si on change l'ordre des oprations:	y2= 440/ 4* 160
 ou si on utilise des parenthses:	y2= 440* ( 160/ 4)
 il n'y a plus de dbordement					    */