/*********************************************************************
*  CH06_06.C  	        	             Variables statiques     *
*                                                                    *
*  Calcul des termes de la srie                                     *
*  de Lonardo Fibonacci (1175-1240) dit Lonard de Pise.            *                                      
*                                                                    *
*  s(n)= s(n-1) + s(n-2)                                             *
*  le terme de rang n est gal  la somme des 2 termes prcdents.   *
*				                                     *
*  S= { 1, 1, 2, 3, 5, 8, 13, ...}	                             *
*                                                                    *
*********************************************************************/

#include<stdio.h>

int LitInt( void);
unsigned long int CalcTerme( int);

main( void)
{
	int i, n;

	printf(" Quel est le nombre de termes  calculer?  ");
	n= LitInt();
	printf("\n");

	for( i= 1; i<= n; i++)
	printf("\n s(%d)= %lu", i, CalcTerme( i) );

}

unsigned long int CalcTerme( int indice)
{
	static unsigned long int s_moins1= 1,  s_moins2= 1;
	unsigned long int terme;

	terme= ( indice< 3) ? 1: s_moins1+ s_moins2;

	s_moins2= s_moins1;
	s_moins1= terme;

	return( terme);
}

int LitInt( void)
{
        int Entier;
	while( scanf("%d", &Entier)!= 1)
		while( getchar() != '\n');
	while( getchar() != '\n');
	return ( Entier);
}
