/*********************************************************************
*  CH07_01.C  	        	               Directives et macros  *
*        			     exemple de table de constantes  *
*             	    				   ( voir cstes.h )  *
*********************************************************************/

/* les constantes sont values en units SI. */

#define PI      3.14159265358979323846
#define C_F 	9.648456e4  	/* constante de Faraday.            */
#define C_G 	6.6720e-11      /* constante de gravitation.        */
#define C_Na 	6.022045e23	/* constante d'Avogadro.            */
#define C_R 	8.31441		/* constante des gaz.               */
#define C_Vm	22.41383e-3	/* volume molaire d'un gaz parfait. */
#define C_c	299792458.0	/* vitesse de la lumire (vide).    */
#define C_e	1.6021892e-19	/* charge lmentaire.              */
#define C_g	9.80665		/* acclration de la pesanteur.    */
#define C_h	6.626176e-34	/* constante de Planck.             */
#define C_k	1.380662e-23	/* constante de Bolzmann.           */
#define C_me	9.109534e-31	/* masse de l'lectron.             */
#define C_mn	1.6749543e-27	/* masse du neutron.                */
#define C_mp	1.6726485e-27	/* masse du proton.                 */
#define C_mT	5.9824e24	/* masse de la Terre.               */
#define C_dST	149.5e9		/* distance moyenne Terre, Soleil   */
#define C_mST	332999.0	/* masse relative Soleil, Terre     */
