/*********************************************************************
*  CH09_06.C  	        	      Jeux de tableaux et pointeurs  *
*********************************************************************/

#include<stdio.h>
#define dim 5

main( void)
{
	int i, tab[dim], *ptr= tab;

/*      Initialisation:                                            */
	for( i= 0; i< dim; i++)  *ptr++= i;

/*      Affichage:                                                 */
	ptr= tab;                   /* retour au dbut du tableau  */
	for( i= 0; i< dim; i++)
	  printf("\n rfrence: %d , tab[%d]= %d", ptr++, i, *ptr);

/*      Etat des lieux  la sortie de boucle:                      */
	printf("\n\n i: %d , rfrence: %d , pointeur: %d\n",
							i, ptr, *ptr);

	ptr-= 5;                    /* retour au dbut du tableau  */
	printf("\n rfrence: %d , pointeur: %d", ptr, *ptr);

	*ptr++;
	printf("\n rfrence: %d , pointeur: %d", ptr, *ptr);

	(*ptr)++;
	printf("\n rfrence: %d , pointeur: %d", ptr, *ptr);

	*++ptr;
	printf("\n rfrence: %d , pointeur: %d", ptr, *ptr);

	++*ptr;
	printf("\n rfrence: %d , pointeur: %d\n", ptr, *ptr);

/*      Affichage:                                                 */
	ptr= tab;                   /* retour au dbut du tableau  */
	for( i= 0; i< dim; i++)
	  printf("\n rfrence: %d , tab[%d]= %d", ptr++, i, *ptr);
}
/*
 rfrence: 6846 , tab[0]= 0
 rfrence: 6848 , tab[1]= 1
 rfrence: 6850 , tab[2]= 2
 rfrence: 6852 , tab[3]= 3
 rfrence: 6854 , tab[4]= 4

  i: 5 , rfrence: 6856 , pointeur= 6866

 rfrence: 6846 , pointeur= 0
 rfrence: 6848 , pointeur= 1
 rfrence: 6848 , pointeur= 2
 rfrence: 6850 , pointeur= 2
 rfrence: 6850 , pointeur= 3

 rfrence: 6846 , tab[0]= 0
 rfrence: 6848 , tab[1]= 2
 rfrence: 6850 , tab[2]= 3
 rfrence: 6852 , tab[3]= 3
 rfrence: 6854 , tab[4]= 4					   */



