/*********************************************************************
*  CH10_03.C  	            Modification d'une chane de caractres  *
*				  Copie d'une chane dans une autre  *
*********************************************************************/

#include<stdio.h>

#define dim 10

void CopieChaine( char*, const char*);

main( void)
{
	int i;
	char chaine0[dim]= "Petrus", chaine1[dim]= "  Albulus";

	printf(" %s %s", chaine0, chaine1);

	CopieChaine( chaine1, chaine0);

	printf("\n %s %s\n", chaine0, chaine1);

	for( i= 0; i< dim; i++)
		printf("\n chaine0[%d]= %c , chaine1[%d]= %c",
					i, chaine0[i], i, chaine1[i]);
}

void CopieChaine( char *destination, const char *source)
{
	char *p= destination;

	while( *source!= '\0')
	{
	   *p++ = *source++;
	}
	*p= '\0';

	/*		la fonction strcpy() contenue dans <string.h>
			fait tout cel beaucoup mieux.  	   */
}

/*

 Petrus   Albulus
 Petrus Petrus

 chaine0[0]= P , chaine1[0]= P
 chaine0[1]= e , chaine1[1]= e
 chaine0[2]= t , chaine1[2]= t
 chaine0[3]= r , chaine1[3]= r
 chaine0[4]= u , chaine1[4]= u
 chaine0[5]= s , chaine1[5]= s
 chaine0[6]=  , chaine1[6]= 
 chaine0[7]=  , chaine1[7]= u
 chaine0[8]=  , chaine1[8]= s
 chaine0[9]=  , chaine1[9]=                                       */

