/*********************************************************************
*  CH12_03.C  	            Exemple d'utilisation d'une numration  *
*********************************************************************/

#include<stdio.h>

void LitChar( char*);

main( void)
{
   char choix= 'z';

   enum test { non, oui} saisie= non;   /* Dfinition, dclaration et
          initialisation de l'numration "saisie" du type "test".  */  

   /* A cet endroit nous avons la dclaration de la structure,
         la saisie du nombre de couples et l'allocation de mmoire. */

   while( choix != 'F')
     {
	printf("\n\t     ---------------------------------------\n"
	"\t     	Saisie des donnes\n"
	"\t     	Vrification\n"
	"\t     	Calcul et affichage\n"
	"\t     	Fin\n"
	"\t     ---------------------------------------\n");

	LitChar( &choix);
	if(  ( choix> 96) && ( choix< 123) )   choix-= 32;

	switch( choix)
	{
	  case 'S':   printf("\n Saisie des donnes: LitTab()");
                      saisie= oui;
		      break;

	  case 'V':   if( saisie== non)
	              {
		         printf("\n Saisissez d'abord les donnes!");
			 break;
		      }
		      printf("\n Vrification des donnes:"
		             " Veriftab()");
		      break;

	  case 'C':   if( saisie!= oui)
	  	      {
		         printf("\n Saisissez d'abord les donnes!");
			 break;
		      }
		      printf("\n Calcul et affichage:"
			     " LitStat()  et GetStat()");
		      break;

	  case 'F':   break;
	  default:    printf("erreur! composez S, V, C ou F\n");
	}
     }
   printf("\t\t***  fin du programme  ***");
}

void LitChar( char *c0)
{
 	while( ( *c0= getchar() )== '\n');
	while( getchar() != '\n');  
}
