/*********************************************************************
*  CH15_01.C  		    		   Enregistrement et lecture *
*  de caractres isols dans un fichier en utilisant putc(), getc()  *
*********************************************************************/

#include<stdio.h>
#include<process.h>                  /* pour la fonction exit()     */

#define fichier "c:\\albulus\\chap_15\\exercice.txt"  

main( void)
{
/* 1. Dclaration de 2 pointeurs sur la structure FILE.             */

	FILE *flux0, *flux1;
	char c;

/* 2. Ouverture d'un fichier en criture.                           */
				    
	flux0= fopen( fichier, "wt");
	if( !flux0)
          {
	     printf("\n Ecriture: le fichier n'a pu tre ouvert!\n");
	     exit( 1);
          }
/* 3. Lecture et enregistrement, un  un,
				    des caractres dans le fichier. */
	do
	{
	    putc( c= getchar(), flux0);
	}
	while( c!= '\n');

/* 4. Fermeture du fichier.                                         */
					    
	fclose( flux0);

/* 5. Ouverture du fichier en lecture.                              */
 		                    
	flux1= fopen( fichier, "rt");
	if( !flux1)
	       printf("\n Lecture: le fichier n'a pu tre ouvert!\n");

/* 6. Lecture et affichage un  un des caractres du fichier.       */

	else
	  do putchar( c= getc( flux1) );
	  while( c!= '\n');

/* 7. Fermeture du fichier.					    */

	fclose( flux1);
}
